Public Class Product
    Inherits System.Object
    Private _id As Integer = -1
    Private _name As String = String.Empty
    Private _category As String = String.Empty
    Private _imageSource As String = String.Empty
    Private _price As Double = 0.0F
    Private _rating As Integer = 0

    Public Sub New(ByVal id As Integer)
        Init(id, String.Empty, String.Empty, 0, 0)
    End Sub

    Public Sub New(ByVal id As Integer, ByVal name As String, ByVal category As String)
        Init(id, name, category, 0, 0)
    End Sub

    Private Sub Init(ByVal id As Integer, ByVal name As String, ByVal category As String, ByVal price As Double, ByVal rating As Integer)
        Dim _id As Integer = id
        Dim _name As String = name
        Dim _category As String = category
        Dim _price As Double = price
        Dim _rating As Integer = rating
    End Sub

    Public ReadOnly Property ID() As Integer
        Get
            Return _id
        End Get
    End Property

    Public Property Name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            _name = value
        End Set
    End Property

    Public Property Category() As String
        Get
            Return _category
        End Get
        Set(ByVal value As String)
            _category = value
        End Set
    End Property

    Public Property ImageSource() As String
        Get
            Return _imageSource
        End Get
        Set(ByVal value As String)
            _imageSource = value
        End Set
    End Property

    Public Property Price() As Double
        Get
            Return _price
        End Get
        Set(ByVal value As Double)
            _price = value
        End Set
    End Property

    Public Property Rating() As Integer
        Get
            Return _rating
        End Get
        Set(ByVal value As Integer)
            _rating = value
        End Set
    End Property
End Class

